// CsEntityVisitor.h

#pragma once

#ifndef _CS_ENTITY_VISITOR_H_
#define _CS_ENTITY_VISITOR_H_

//------------------------------------------------------------------------------

struct CsEntity;
struct CsEntityNamespace;
//struct CsEntityGlobalNamespace;
struct CsEntityBlock;
struct CsEntityFormalParameter;
struct CsEntityFormalParameterList;
struct CsEntityMethod;
struct CsEntityClass;
struct CsEntityStruct;
struct CsEntityInterface;
struct CsEntityEnum;
struct CsEntityConstant;
struct CsEntityVariable;
struct CsEntityBlockVariable;
struct CsEntityDelegate;
struct CsEntityProperty;
struct CsEntityEvent;
struct CsEntityLocalConstant;
struct CsEntityLocalVariable;
struct CsEntityUsingAliasDirective;
struct CsEntityLabel;

//------------------------------------------------------------------------------
// CsEntityVisitor
//------------------------------------------------------------------------------

class CsEntityVisitor
{
public:
	//virtual void visit ( CsEntityGlobalNamespace * entity ) {}
	virtual void visit ( CsEntityNamespace * entity ) {}
	virtual void visit ( CsEntityBlock * entity ) {}
	virtual void visit ( CsEntityFormalParameter * entity ) {}
	virtual void visit ( CsEntityFormalParameterList * entity ) {}
	virtual void visit ( CsEntityMethod * entity ) {}
	virtual void visit ( CsEntityClass * entity ) {}
	virtual void visit ( CsEntityStruct * entity ) {}
	virtual void visit ( CsEntityInterface * entity ) {}
	virtual void visit ( CsEntityEnum * entity ) {}
	virtual void visit ( CsEntityConstant * entity ) {}
	virtual void visit ( CsEntityVariable * entity ) {}
	virtual void visit ( CsEntityBlockVariable * entity ) {}
	virtual void visit ( CsEntityDelegate * entity ) {}
	virtual void visit ( CsEntityProperty * entity ) {}
	virtual void visit ( CsEntityEvent * entity ) {}
	virtual void visit ( CsEntityLocalConstant * entity ) {}
	virtual void visit ( CsEntityLocalVariable * entity ) {}
	virtual void visit ( CsEntityUsingAliasDirective * entity ) {}
	virtual void visit ( CsEntityLabel * entity ) {}
};

//------------------------------------------------------------------------------

#endif // _CS_ENTITY_VISITOR_H_

